Index: /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/NST_SRC/agrif_top_interp.F90
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/NST_SRC/agrif_top_interp.F90	(revision 3679)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/NST_SRC/agrif_top_interp.F90	(revision 3680)
@@ -27,49 +27,86 @@
 
    SUBROUTINE Agrif_trc
-      !!---------------------------------------------
-      !!   *** ROUTINE Agrif_trc ***
-      !!---------------------------------------------
-      
-      INTEGER :: ji,jj,jk,jn
-      REAL(wp) :: zrhox
-      REAL(wp) :: alpha1, alpha2, alpha3, alpha4
-      REAL(wp) :: alpha5, alpha6, alpha7
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE Agrif_Tra  ***
+      !!----------------------------------------------------------------------
+      !!
+      INTEGER  ::   ji, jj, jk, jn   ! dummy loop indices
+      REAL(wp) ::   zrhox , alpha1, alpha2, alpha3
+      REAL(wp) ::   alpha4, alpha5, alpha6, alpha7
       REAL(wp), POINTER, DIMENSION(:,:,:,:) :: ztra
-           
-      IF (Agrif_Root()) RETURN
+      !!----------------------------------------------------------------------
+      !
+      IF( Agrif_Root() )   RETURN
 
       CALL wrk_alloc( jpi, jpj, jpk, jptra, ztra )
 
-      Agrif_SpecialValue=0.
+      Agrif_SpecialValue    = 0.e0
       Agrif_UseSpecialValue = .TRUE.
-      ztra = 0.e0
+      ztra(:,:,:,:) = 0.e0
 
-      CALL Agrif_Bc_variable(ztra,trn_id, procname = interptrn )
+      CALL Agrif_Bc_variable( ztra, trn_id, procname=interptrn )
       Agrif_UseSpecialValue = .FALSE.
 
       zrhox = Agrif_Rhox()
 
-      alpha1 = (zrhox-1.)/2.
-      alpha2 = 1.-alpha1
+      alpha1 = ( zrhox - 1. ) * 0.5
+      alpha2 = 1. - alpha1
 
-      alpha3 = (zrhox-1)/(zrhox+1)
-      alpha4 = 1.-alpha3
+      alpha3 = ( zrhox - 1. ) / ( zrhox + 1. )
+      alpha4 = 1. - alpha3
 
-      alpha6 = 2.*(zrhox-1.)/(zrhox+1.)
-      alpha7 = -(zrhox-1)/(zrhox+3)
+      alpha6 = 2. * ( zrhox - 1. ) / ( zrhox + 1. )
+      alpha7 =    - ( zrhox - 1. ) / ( zrhox + 3. )
       alpha5 = 1. - alpha6 - alpha7
+      IF( nbondi == 1 .OR. nbondi == 2 ) THEN
 
-      IF ((nbondi == 1).OR.(nbondi == 2)) THEN
-         tra(nlci,:,:,:) = alpha1 * ztra(nlci,:,:,:) + alpha2 * ztra(nlci-1,:,:,:)
-         DO jn=1,jptra 
-            DO jk=1,jpk      
-               DO jj=1,jpj
-                  IF (umask(nlci-2,jj,jk).EQ.0.) THEN
+         DO jn = 1, jptra
+            tra(nlci,:,:,jn) = alpha1 * ztra(nlci,:,:,jn) + alpha2 * ztra(nlci-1,:,:,jn)
+            DO jk = 1, jpkm1
+               DO jj = 1, jpj
+                  IF( umask(nlci-2,jj,jk) == 0.e0 ) THEN
                      tra(nlci-1,jj,jk,jn) = tra(nlci,jj,jk,jn) * tmask(nlci-1,jj,jk)
                   ELSE
                      tra(nlci-1,jj,jk,jn)=(alpha4*tra(nlci,jj,jk,jn)+alpha3*tra(nlci-2,jj,jk,jn))*tmask(nlci-1,jj,jk)
-                     IF (un(nlci-2,jj,jk).GT.0.) THEN
-                        tra(nlci-1,jj,jk,jn)=(alpha6*tra(nlci-2,jj,jk,jn)+alpha5*tra(nlci,jj,jk,jn) &
-                           +alpha7*tra(nlci-3,jj,jk,jn))*tmask(nlci-1,jj,jk)
+                     IF( un(nlci-2,jj,jk) > 0.e0 ) THEN
+                        tra(nlci-1,jj,jk,jn)=( alpha6*tra(nlci-2,jj,jk,jn)+alpha5*tra(nlci,jj,jk,jn)  &
+                           &                 + alpha7*tra(nlci-3,jj,jk,jn) ) * tmask(nlci-1,jj,jk)
+                     ENDIF
+                  ENDIF
+               END DO
+            END DO
+         ENDDO
+      ENDIF
+
+      IF( nbondj == 1 .OR. nbondj == 2 ) THEN
+
+         DO jn = 1, jptra
+            tra(:,nlcj,:,jn) = alpha1 * ztra(:,nlcj,:,jn) + alpha2 * ztra(:,nlcj-1,:,jn)
+            DO jk = 1, jpkm1
+               DO ji = 1, jpi
+                  IF( vmask(ji,nlcj-2,jk) == 0.e0 ) THEN
+                     tra(ji,nlcj-1,jk,jn) = tra(ji,nlcj,jk,jn) * tmask(ji,nlcj-1,jk)
+                  ELSE
+                     tra(ji,nlcj-1,jk,jn)=(alpha4*tra(ji,nlcj,jk,jn)+alpha3*tra(ji,nlcj-2,jk,jn))*tmask(ji,nlcj-1,jk)
+                     IF (vn(ji,nlcj-2,jk) > 0.e0 ) THEN
+                        tra(ji,nlcj-1,jk,jn)=( alpha6*tra(ji,nlcj-2,jk,jn)+alpha5*tra(ji,nlcj,jk,jn)  &
+                           &                 + alpha7*tra(ji,nlcj-3,jk,jn) ) * tmask(ji,nlcj-1,jk)
+                     ENDIF
+                  ENDIF
+               END DO
+            END DO
+         ENDDO
+      ENDIF
+      IF( nbondi == -1 .OR. nbondi == 2 ) THEN
+         DO jn = 1, jptra
+            tra(1,:,:,jn) = alpha1 * ztra(1,:,:,jn) + alpha2 * ztra(2,:,:,jn)
+            DO jk = 1, jpkm1
+               DO jj = 1, jpj
+                  IF( umask(2,jj,jk) == 0.e0 ) THEN
+                     tra(2,jj,jk,jn) = tra(1,jj,jk,jn) * tmask(2,jj,jk)
+                  ELSE
+                     tra(2,jj,jk,jn)=(alpha4*tra(1,jj,jk,jn)+alpha3*tra(3,jj,jk,jn))*tmask(2,jj,jk)
+                     IF( un(2,jj,jk) < 0.e0 ) THEN
+                        tra(2,jj,jk,jn)=(alpha6*tra(3,jj,jk,jn)+alpha5*tra(1,jj,jk,jn)+alpha7*tra(4,jj,jk,jn))*tmask(2,jj,jk)
                      ENDIF
                   ENDIF
@@ -79,62 +116,24 @@
       ENDIF
 
-      IF ((nbondj == 1).OR.(nbondj == 2)) THEN
-         tra(:,nlcj,:,:) = alpha1 * ztra(:,nlcj,:,:) + alpha2 * ztra(:,nlcj-1,:,:)
-         DO jn=1, jptra            
-            DO jk=1,jpk      
+      IF( nbondj == -1 .OR. nbondj == 2 ) THEN
+         DO jn = 1, jptra
+            tra(:,1,:,jn) = alpha1 * ztra(:,1,:,jn) + alpha2 * ztra(:,2,:,jn)
+            DO jk=1,jpk
                DO ji=1,jpi
-                  IF (vmask(ji,nlcj-2,jk).EQ.0.) THEN
-                     tra(ji,nlcj-1,jk,jn) = tra(ji,nlcj,jk,jn) * tmask(ji,nlcj-1,jk)
+                  IF( vmask(ji,2,jk) == 0.e0 ) THEN
+                     tra(ji,2,jk,jn)=tra(ji,1,jk,jn) * tmask(ji,2,jk)
                   ELSE
-                     tra(ji,nlcj-1,jk,jn)=(alpha4*tra(ji,nlcj,jk,jn)+alpha3*tra(ji,nlcj-2,jk,jn))*tmask(ji,nlcj-1,jk)        
-                     IF (vn(ji,nlcj-2,jk) .GT. 0.) THEN
-                        tra(ji,nlcj-1,jk,jn)=(alpha6*tra(ji,nlcj-2,jk,jn)+alpha5*tra(ji,nlcj,jk,jn) &
-                           +alpha7*tra(ji,nlcj-3,jk,jn))*tmask(ji,nlcj-1,jk)
+                     tra(ji,2,jk,jn)=(alpha4*tra(ji,1,jk,jn)+alpha3*tra(ji,3,jk,jn))*tmask(ji,2,jk)
+                     IF( vn(ji,2,jk) < 0.e0 ) THEN
+                        tra(ji,2,jk,jn)=(alpha6*tra(ji,3,jk,jn)+alpha5*tra(ji,1,jk,jn)+alpha7*tra(ji,4,jk,jn))*tmask(ji,2,jk)
                      ENDIF
                   ENDIF
                END DO
             END DO
-         END DO
+         ENDDO
       ENDIF
-
-      IF ((nbondi == -1).OR.(nbondi == 2)) THEN
-         tra(1,:,:,:) = alpha1 * ztra(1,:,:,:) + alpha2 * ztra(2,:,:,:)
-         DO jn=1, jptra
-            DO jk=1,jpk      
-               DO jj=1,jpj
-                  IF (umask(2,jj,jk).EQ.0.) THEN
-                     tra(2,jj,jk,jn) = tra(1,jj,jk,jn) * tmask(2,jj,jk)
-                  ELSE
-                     tra(2,jj,jk,jn)=(alpha4*tra(1,jj,jk,jn)+alpha3*tra(3,jj,jk,jn))*tmask(2,jj,jk)        
-                     IF (un(2,jj,jk).LT.0.) THEN
-                        tra(2,jj,jk,jn)=(alpha6*tra(3,jj,jk,jn)+alpha5*tra(1,jj,jk,jn) &
-                           +alpha7*tra(4,jj,jk,jn))*tmask(2,jj,jk)
-                     ENDIF
-                  ENDIF
-               END DO
-            END DO
-         END DO
-      ENDIF
-
-      IF ((nbondj == -1).OR.(nbondj == 2)) THEN
-         tra(:,1,:,:) = alpha1 * ztra(:,1,:,:) + alpha2 * ztra(:,2,:,:)
-         DO jn=1, jptra  
-            DO jk=1,jpk      
-               DO ji=1,jpi
-                  IF (vmask(ji,2,jk).EQ.0.) THEN
-                     tra(ji,2,jk,jn)=tra(ji,1,jk,jn) * tmask(ji,2,jk)
-                  ELSE
-                     tra(ji,2,jk,jn)=(alpha4*tra(ji,1,jk,jn)+alpha3*tra(ji,3,jk,jn))*tmask(ji,2,jk)
-                     IF (vn(ji,2,jk) .LT. 0.) THEN
-                        tra(ji,2,jk,jn)=(alpha6*tra(ji,3,jk,jn)+alpha5*tra(ji,1,jk,jn)&
-                           +alpha7*tra(ji,4,jk,jn))*tmask(ji,2,jk)
-                     ENDIF
-                  ENDIF
-               END DO
-            END DO
-         END DO
-      ENDIF
-
+      !
       CALL wrk_dealloc( jpi, jpj, jpk, jptra, ztra )
+      !
 
    END SUBROUTINE Agrif_trc
Index: /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/NST_SRC/agrif_top_sponge.F90
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/NST_SRC/agrif_top_sponge.F90	(revision 3679)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/NST_SRC/agrif_top_sponge.F90	(revision 3680)
@@ -8,4 +8,5 @@
    USE in_out_manager
    USE agrif_oce
+   USE agrif_opa_sponge
    USE trc
    USE lib_mpp
@@ -17,4 +18,6 @@
    PUBLIC Agrif_Sponge_Trc, interptrn
 
+  !! * Substitutions
+#  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/NST 3.3 , NEMO Consortium (2010)
@@ -29,16 +32,15 @@
       !!   *** ROUTINE Agrif_Sponge_Trc ***
       !!---------------------------------------------
-#include "domzgr_substitute.h90"
       !! 
-      INTEGER :: ji,jj,jk,jl
-      INTEGER :: spongearea
+      INTEGER :: ji,jj,jk,jn
       REAL(wp) :: timecoeff
       REAL(wp) :: ztra, zabe1, zabe2, zbtr
-      REAL(wp), POINTER, DIMENSION(:,:) :: localviscsponge
-      REAL(wp), POINTER, DIMENSION(:,:,:,:) :: trbdiff, ztru, ztrv, ztab
+      REAL(wp), POINTER, DIMENSION(:,:) :: ztru, ztrv
+      REAL(wp), POINTER, DIMENSION(:,:,:,:) :: ztabr
+      REAL(wp), POINTER, DIMENSION(:,:,:,:) :: trbdiff
 
 #if defined SPONGE_TOP
-      CALL wrk_alloc( jpi, jpj, localviscsponge )
-      CALL wrk_alloc( jpi, jpj, jpk, jptra, trbdiff, ztru, ztrv, ztab )
+      CALL wrk_alloc( jpi, jpj, ztru, ztrv )
+      CALL wrk_alloc( jpi, jpj, jpk, jptra, ztabr, trbdiff )
 
       timecoeff = REAL(Agrif_NbStepint(),wp)/Agrif_rhot()
@@ -46,106 +48,39 @@
       Agrif_SpecialValue=0.
       Agrif_UseSpecialValue = .TRUE.
-      ztab = 0.e0
-      CALL Agrif_Bc_Variable(ztab, tra_id,calledweight=timecoeff,procname=interptrn)
+      ztabr = 0.e0
+      CALL Agrif_Bc_Variable(ztabr, tra_id,calledweight=timecoeff,procname=interptrn)
       Agrif_UseSpecialValue = .FALSE.
 
-      trbdiff(:,:,:,:) = trb(:,:,:,:) - ztab(:,:,:,:)
+      trbdiff(:,:,:,:) = trb(:,:,:,:) - ztabr(:,:,:,:)
 
-      spongearea = 2 + 2 * Agrif_irhox()
+      CALL Agrif_sponge
 
-      localviscsponge = 0.
-      
-      IF (.NOT. spongedoneT) THEN
-         spe1ur(:,:) = 0.
-         spe2vr(:,:) = 0.
+      DO jn = 1, jptra
+         DO jk = 1, jpkm1
+            !
+            DO jj = 1, jpjm1
+               DO ji = 1, jpim1
+                  zabe1 = umask(ji,jj,jk) * spe1ur(ji,jj) * fse3u(ji,jj,jk)
+                  zabe2 = vmask(ji,jj,jk) * spe2vr(ji,jj) * fse3v(ji,jj,jk)
+                  ztru(ji,jj) = zabe1 * ( trbdiff(ji+1,jj  ,jk,jn) - trbdiff(ji,jj,jk,jn) )
+                  ztrv(ji,jj) = zabe2 * ( trbdiff(ji  ,jj+1,jk,jn) - trbdiff(ji,jj,jk,jn) )
+               ENDDO
+            ENDDO
 
-      IF ((nbondi == -1).OR.(nbondi == 2)) THEN
-         DO ji = 2, spongearea
-            localviscsponge(ji,:) = visc_tra * (spongearea-ji)/real(spongearea-2)
+            DO jj = 2,jpjm1
+               DO ji = 2,jpim1
+                  zbtr = spbtr2(ji,jj) / fse3t(ji,jj,jk)
+                  ! horizontal diffusive trends
+                  ztra = zbtr * ( ztru(ji,jj) - ztru(ji-1,jj) + ztrv(ji,jj) - ztrv(ji,jj-1)  )
+                  ! add it to the general tracer trends
+                  tra(ji,jj,jk,jn) = tra(ji,jj,jk,jn) + ztra
+               END DO
+            END DO
+            !
          ENDDO
-	 
-	 spe1ur(2:spongearea-1,:)=0.5 * (localviscsponge(2:spongearea-1,:) + localviscsponge(3:spongearea,:)) &
-	       * e2u(2:spongearea-1,:) / e1u(2:spongearea-1,:)
-
-         spe2vr(2:spongearea,1:jpjm1) = 0.5 * (localviscsponge(2:spongearea,1:jpjm1) + &
-	          localviscsponge(2:spongearea,2:jpj)) &
-	        * e1v(2:spongearea,1:jpjm1) / e2v(2:spongearea,1:jpjm1)
-      ENDIF
-
-      IF ((nbondi == 1).OR.(nbondi == 2)) THEN
-         DO ji = nlci-spongearea + 1,nlci-1
-            localviscsponge(ji,:) = visc_tra * (ji - (nlci-spongearea+1))/real(spongearea-2)
-         ENDDO
-	 
-	 spe1ur(nlci-spongearea + 1:nlci-2,:)=0.5 * (localviscsponge(nlci-spongearea + 1:nlci-2,:) + &
-	        localviscsponge(nlci-spongearea + 2:nlci-1,:)) &
-	       * e2u(nlci-spongearea + 1:nlci-2,:) / e1u(nlci-spongearea + 1:nlci-2,:)
-
-         spe2vr(nlci-spongearea + 1:nlci-1,1:jpjm1) = 0.5 * (localviscsponge(nlci-spongearea + 1:nlci-1,1:jpjm1) &
-	           + localviscsponge(nlci-spongearea + 1:nlci-1,2:jpj)) &
-	        * e1v(nlci-spongearea + 1:nlci-1,1:jpjm1) / e2v(nlci-spongearea + 1:nlci-1,1:jpjm1)
-      ENDIF
-
-
-      IF ((nbondj == -1).OR.(nbondj == 2)) THEN
-         DO jj = 2, spongearea
-            localviscsponge(:,jj) = visc_tra * (spongearea-jj)/real(spongearea-2)
-         ENDDO
-	 
-	 spe1ur(1:jpim1,2:spongearea)=0.5 * (localviscsponge(1:jpim1,2:spongearea) + &
-	        localviscsponge(2:jpi,2:spongearea)) &
-	       * e2u(1:jpim1,2:spongearea) / e1u(1:jpim1,2:spongearea)
-
-         spe2vr(:,2:spongearea-1) = 0.5 * (localviscsponge(:,2:spongearea-1) + &
-	          localviscsponge(:,3:spongearea)) &
-	        * e1v(:,2:spongearea-1) / e2v(:,2:spongearea-1)
-      ENDIF
-
-      IF ((nbondj == 1).OR.(nbondj == 2)) THEN
-         DO jj = nlcj-spongearea + 1,nlcj-1
-            localviscsponge(:,jj) = visc_tra * (jj - (nlcj-spongearea+1))/real(spongearea-2)
-         ENDDO
-	 
-	 spe1ur(1:jpim1,nlcj-spongearea + 1:nlcj-1)=0.5 * (localviscsponge(1:jpim1,nlcj-spongearea + 1:nlcj-1) + &
-	         localviscsponge(2:jpi,nlcj-spongearea + 1:nlcj-1)) &
-	       * e2u(1:jpim1,nlcj-spongearea + 1:nlcj-1) / e1u(1:jpim1,nlcj-spongearea + 1:nlcj-1)
-
-         spe2vr(:,nlcj-spongearea + 1:nlcj-2) = 0.5 * (localviscsponge(:,nlcj-spongearea + 1:nlcj-2) + &
-	         localviscsponge(:,nlcj-spongearea + 2:nlcj-1)) &
-	        * e1v(:,nlcj-spongearea + 1:nlcj-2) / e2v(:,nlcj-spongearea + 1:nlcj-2)
-      ENDIF
-      
-         spbtr2(:,:) = 1. / ( e1t(:,:) * e2t(:,:))
-
-         spongedoneT = .TRUE.
-      ENDIF
-
-      DO jl = 1, jptra
-      DO jk = 1, jpkm1
-         DO jj = 1, jpjm1
-            DO ji = 1, jpim1
-               zabe1 = umask(ji,jj,jk) * spe1ur(ji,jj) * fse3u(ji,jj,jk)
-               zabe2 = vmask(ji,jj,jk) * spe2vr(ji,jj) * fse3v(ji,jj,jk)
-               ztru(ji,jj,jk,jl) = zabe1 * ( trbdiff(ji+1,jj  ,jk,jl) - trbdiff(ji,jj,jk,jl) )
-               ztrv(ji,jj,jk,jl) = zabe2 * ( trbdiff(ji  ,jj+1,jk,jl) - trbdiff(ji,jj,jk,jl) )
-            ENDDO
-         ENDDO
-
-         DO jj = 2,jpjm1
-            DO ji = 2,jpim1
-               zbtr = spbtr2(ji,jj) / fse3t(ji,jj,jk)
-               ! horizontal diffusive trends
-               ztra = zbtr * (  ztru(ji,jj,jk,jl) - ztru(ji-1,jj,jk,jl)   &
-                  &          + ztrv(ji,jj,jk,jl) - ztrv(ji,jj-1,jk,jl)  )
-               ! add it to the general tracer trends
-               tra(ji,jj,jk,jl) = (tra(ji,jj,jk,jl) + ztra)
-            END DO
-         END DO
-
-      ENDDO
       ENDDO
  
-      CALL wrk_dealloc( jpi, jpj, localviscsponge )
-      CALL wrk_dealloc( jpi, jpj, jpk, jptra, trbdiff, ztru, ztrv, ztab )
+      CALL wrk_dealloc( jpi, jpj, ztru, ztrv )
+      CALL wrk_dealloc( jpi, jpj, jpk, jptra, trbdiff, ztabr )
 
 #endif
@@ -153,14 +88,12 @@
    END SUBROUTINE Agrif_Sponge_Trc
 
-   SUBROUTINE interptrn(tabres,i1,i2,j1,j2,k1,k2,l1,l2)
+   SUBROUTINE interptrn(tabres,i1,i2,j1,j2,k1,k2,n1,n2)
       !!---------------------------------------------
       !!   *** ROUTINE interptn ***
       !!---------------------------------------------
-#  include "domzgr_substitute.h90"       
-      
-      INTEGER, INTENT(in) :: i1,i2,j1,j2,k1,k2,l1,l2
-      REAL(wp), DIMENSION(i1:i2,j1:j2,k1:k2,l1:l2), INTENT(inout) :: tabres
-
-      tabres(i1:i2,j1:j2,k1:k2,l1:l2) = trn(i1:i2,j1:j2,k1:k2,l1:l2)
+      INTEGER, INTENT(in) :: i1,i2,j1,j2,k1,k2,n1,n2
+      REAL(wp), DIMENSION(i1:i2,j1:j2,k1:k2,n1:n2), INTENT(inout) :: tabres
+      !
+      tabres(i1:i2,j1:j2,k1:k2,n1:n2) = trn(i1:i2,j1:j2,k1:k2,n1:n2)
 
    END SUBROUTINE interptrn
Index: /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/NST_SRC/agrif_top_update.F90
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/NST_SRC/agrif_top_update.F90	(revision 3679)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/NST_SRC/agrif_top_update.F90	(revision 3680)
@@ -38,5 +38,5 @@
 
 #if defined TWO_WAY
-      CALL wrk_alloc( jpi, jpj, jpk, jpts, ztra )
+      CALL wrk_alloc( jpi, jpj, jpk, jptra, ztra )
 
       Agrif_UseSpecialValueInUpdate = .TRUE.
@@ -52,27 +52,25 @@
       nbcline_trc = nbcline_trc + 1
 
-      CALL wrk_dealloc( jpi, jpj, jpk, jpts, ztra )
+      CALL wrk_dealloc( jpi, jpj, jpk, jptra, ztra )
 #endif
 
    END SUBROUTINE Agrif_Update_Trc
 
-   SUBROUTINE updateTRC(tabres,i1,i2,j1,j2,k1,k2,l1,l2,before)
+   SUBROUTINE updateTRC(tabres,i1,i2,j1,j2,k1,k2,n1,n2,before)
       !!---------------------------------------------
       !!   *** ROUTINE UpdateTrc ***
       !!---------------------------------------------
-#  include "domzgr_substitute.h90"
-
-      INTEGER, INTENT(in) :: i1,i2,j1,j2,k1,k2,l1,l2
-      REAL, DIMENSION(i1:i2,j1:j2,k1:k2,l1:l2), INTENT(inout) :: tabres
+      INTEGER, INTENT(in) :: i1,i2,j1,j2,k1,k2,n1,n2
+      REAL, DIMENSION(i1:i2,j1:j2,k1:k2,n1:n2), INTENT(inout) :: tabres
       LOGICAL, INTENT(in) :: before
    
-      INTEGER :: ji,jj,jk,jl
+      INTEGER :: ji,jj,jk,jn
 
-         IF (before) THEN
-            DO jl=l1,l2
-               DO jk=k1,k2
-                  DO jj=j1,j2
-                     DO ji=i1,i2
-                        tabres(ji,jj,jk,jl) = trn(ji,jj,jk,jl)
+         IF( before ) THEN
+            DO jn = n1, n2
+               DO jk = k1, k2
+                  DO jj = j1, j2
+                     DO ji = i1, i2
+                        tabres(ji,jj,jk,jn) = trn(ji,jj,jk,jn)
                      ENDDO
                   ENDDO
@@ -80,10 +78,10 @@
             ENDDO
          ELSE
-            DO jl=l1,l2
-               DO jk=k1,k2
-                  DO jj=j1,j2
-                     DO ji=i1,i2
-                        IF (tabres(ji,jj,jk,jl).NE.0.) THEN
-                           trn(ji,jj,jk,jl) = tabres(ji,jj,jk,jl) * tmask(ji,jj,jk)
+            DO jn = n1, n2
+               DO jk = k1, k2
+                  DO jj = j1, j2
+                     DO ji = i1, i2
+                        IF( tabres(ji,jj,jk,jn) .NE. 0. ) THEN
+                           trn(ji,jj,jk,jn) = tabres(ji,jj,jk,jn) * tmask(ji,jj,jk)
                         ENDIF
                      ENDDO
